=encoding utf8

=head1 NAME

Mail::Box::Manage::User - manage the folders of a user

=head1 INHERITANCE

 Mail::Box::Manage::User
   is a Mail::Box::Manager
   is a Mail::Reporter

 Mail::Box::Manage::User is extended by
   Mail::Server::IMAP4::User

=head1 SYNOPSIS

  use Mail::Box::Manage::User;
  use User::Identity;

  my $id      = User::Identity->new(...);
  my $user    = Mail::Box::Manage::User->new(
    identity  => $id,
    folderdir => "$ENV{HOME}/Mail",
    inbox     => $ENV{MAIL},
  );

  my $inbox   = $user->open($user->inbox);
  my $top     = $user->topfolder;

=head1 DESCRIPTION

Where the L<Mail::Box::Manager|Mail::Box::Manager> takes care of some set of open folder,
this extension will add knowledge about some related person.  At the
same time, it will try to cache some information about that person's
folder files.

Extends L<"DESCRIPTION" in Mail::Box::Manager|Mail::Box::Manager/"DESCRIPTION">.

=head1 METHODS

Extends L<"METHODS" in Mail::Box::Manager|Mail::Box::Manager/"METHODS">.

=head2 Constructors

Extends L<"Constructors" in Mail::Box::Manager|Mail::Box::Manager/"Constructors">.

=over 4

=item $class-E<gt>B<new>(%options)

Use L<new(default_folder_type)|Mail::Box::Manager/"METHODS"> to explicitly state which kind of folders
you use.
Improves base, see L<Mail::Reporter/"Constructors">

 -Option             --Defined in        --Default
  autodetect           Mail::Box::Manager  undef
  collection_type                          Mail::Box::Collection
  default_folder_type  Mail::Box::Manager  'mbox'
  delimiter                                "/"
  folder_id_type                           Mail::Box::Identity
  folder_types         Mail::Box::Manager  <all standard types>
  folderdir            Mail::Box::Manager  [ '.' ]
  folderdirs           Mail::Box::Manager  <synonym for C<folderdir>>
  identity                                 <required>
  inbox                                    undef
  topfolder_name                           '='

=over 2

=item autodetect => $type|\@types

=item collection_type => $class

Subfolders grouped together.

=item default_folder_type => $type|CLASS

=item delimiter => STRING

The separator used in folder names.  This doesn't need to be the
same as your directory system is using.

=item folder_id_type => CLASS|OBJECT

=item folder_types => $typedef|\@typedefs

=item folderdir => DIRECTORY

=item folderdirs => [DIRECTORIES]

=item identity => OBJECT

The main difference between the L<Mail::Box::Manager|Mail::Box::Manager> and this class, is
the concept of some person (or virtual person) who's files are being
administered by this object.  The OBJECT is an L<User::Identity|User::Identity>.

The smallest identity that will do: C<< my $id = User::Identity->new('myname') >>

=item inbox => $name

The C<$name> of the user's inbox.

=item topfolder_name => $name

=back

=back

=head2 Attributes

Extends L<"Attributes" in Mail::Box::Manager|Mail::Box::Manager/"Attributes">.

=over 4

=item $obj-E<gt>B<defaultFolderType>()

Inherited, see L<Mail::Box::Manager/"Attributes">

=item $obj-E<gt>B<delimiter>()

Folder path delimiter

=item $obj-E<gt>B<folderTypeDefs>()

Inherited, see L<Mail::Box::Manager/"Attributes">

=item $obj-E<gt>B<folderTypes>()

Inherited, see L<Mail::Box::Manager/"Attributes">

=item $obj-E<gt>B<folderdir>()

Inherited, see L<Mail::Box::Manager/"Attributes">

=item $obj-E<gt>B<identity>()

Returns a L<User::Identity|User::Identity> object.

=item $obj-E<gt>B<inbox>( [$name] )

(Set and) get the C<$name> of the mailbox which is considered the folder
for incoming mail.  In many protocols, this folder is handled separately.
For instance in IMAP this is the only case-insensitive folder name.

=item $obj-E<gt>B<registerType>($type, $class, %options)

Inherited, see L<Mail::Box::Manager/"Attributes">

=item $obj-E<gt>B<threads>( [@params] )

Inherited, see L<Mail::Box::Manager/"Attributes">

=item $obj-E<gt>B<topfolder>()

Returns the top folder of the user's mailbox storage.

=back

=head2 Manage open folders

Extends L<"Manage open folders" in Mail::Box::Manager|Mail::Box::Manager/"Manage open folders">.

=over 4

=item $obj-E<gt>B<close>($folder, %options)

Inherited, see L<Mail::Box::Manager/"Manage open folders">

=item $obj-E<gt>B<closeAllFolders>(%options)

Inherited, see L<Mail::Box::Manager/"Manage open folders">

=item $obj-E<gt>B<isOpenFolder>($folder)

Inherited, see L<Mail::Box::Manager/"Manage open folders">

=item $obj-E<gt>B<open>( [$foldername], %options )

Inherited, see L<Mail::Box::Manager/"Manage open folders">

=item $obj-E<gt>B<openFolders>()

Inherited, see L<Mail::Box::Manager/"Manage open folders">

=back

=head2 Manage existing folders

Extends L<"Manage existing folders" in Mail::Box::Manager|Mail::Box::Manager/"Manage existing folders">.

=over 4

=item $obj-E<gt>B<create>($name, %options)

Creates a new folder with the specified name.  An folder's administrative
structure (L<Mail::Box::Identity|Mail::Box::Identity>) is returned, but the folder is not
opened.

In the accidental case that the folder already
exists, a warning will be issued, and an empty list/C<undef> returned.

The C<%options> are passed to L<Mail::Box::create()|Mail::Box/"Internals"> of your default folder
type, except for the options intended for this method itself.

 -Option       --Default
  create_real    true
  create_supers  false
  deleted        false
  id_options     []

=over 2

=item create_real => BOOLEAN

When this option is C<false>, the pysical folder will not be created, but
only the administration is updated.

=item create_supers => BOOLEAN

When you create a folder where upper hierarchy level are missing, they
will be created as well.

=item deleted => BOOLEAN

The folder starts as deleted.

=item id_options => ARRAY

Values passed to the instantiated L<Mail::Box::Identity|Mail::Box::Identity>.  That object
is very picky about the initiation values it accepts.

=back

=item $obj-E<gt>B<delete>($name)

Remove all signs from the folder on the file-system.  Messages still in
the folder will be removed.  This method returns a C<true> value when the
folder has been removed or not found, so "C<false>" means failure.

It is also possible to delete a folder using C<< $folder->delete >>,
which will call this method here.  OPTIONS, which are used for some
other folder types, will be ignored here: the user's index contains the
required details.
Improves base, see L<Mail::Box::Manager/"Manage existing folders">

 -Option   --Defined in        --Default
  recursive  Mail::Box::Manager  <folder's default>

=over 2

=item recursive => BOOLEAN

=back

» example: how to delete a folder

  print "no xyz (anymore)\n" if $user->delete('xyz');

=item $obj-E<gt>B<folder>($name)

Returns the folder description, a L<Mail::Box::Identity|Mail::Box::Identity>.

=item $obj-E<gt>B<folderCollection>($name)

Returns a pair: the folder collection (L<Mail::Box::Collection|Mail::Box::Collection>) and
the base name of C<$name>.

=item $obj-E<gt>B<rename>($oldname, $newname, %options)

Rename the folder with name C<$oldname> to C<$newname>.  Both names are full
pathnames.

 -Option       --Default
  create_supers  false

=over 2

=item create_supers => BOOLEAN

When you rename a folder to a place where upper hierarchy levels are
missing, they will get be defined, but with the deleted flag set.

=back

=back

=head2 Move messages to folders

Extends L<"Move messages to folders" in Mail::Box::Manager|Mail::Box::Manager/"Move messages to folders">.

=over 4

=item $obj-E<gt>B<appendMessage>( [$folder|$foldername], $messages, %options )

Inherited, see L<Mail::Box::Manager/"Move messages to folders">

=item $obj-E<gt>B<copyMessage>( [$folder|$foldername], @messages, %options )

Inherited, see L<Mail::Box::Manager/"Move messages to folders">

=item $obj-E<gt>B<moveMessage>( [$folder|$foldername], @messages, %options )

Inherited, see L<Mail::Box::Manager/"Move messages to folders">

=back

=head2 Manage message threads

Extends L<"Manage message threads" in Mail::Box::Manager|Mail::Box::Manager/"Manage message threads">.

=over 4

=item $obj-E<gt>B<discoverThreads>( [@folders], %options )

Inherited, see L<Mail::Box::Manager/"Manage message threads">

=back

=head2 Internals

Extends L<"Internals" in Mail::Box::Manager|Mail::Box::Manager/"Internals">.

=over 4

=item $obj-E<gt>B<decodeFolderURL>($url)

Inherited, see L<Mail::Box::Manager/"Internals">

=item $obj-E<gt>B<toBeThreaded>($folder, $messages)

Inherited, see L<Mail::Box::Manager/"Internals">

=item $obj-E<gt>B<toBeUnthreaded>($folder, $messages)

Inherited, see L<Mail::Box::Manager/"Internals">

=back

=head2 Error handling

Extends L<"Error handling" in Mail::Box::Manager|Mail::Box::Manager/"Error handling">.

=over 4

=item $obj-E<gt>B<AUTOLOAD>()

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<notImplemented>()

Inherited, see L<Mail::Reporter/"Error handling">

=back

=head2 Cleanup

Extends L<"Cleanup" in Mail::Box::Manager|Mail::Box::Manager/"Cleanup">.

=over 4

=item $obj-E<gt>B<DESTROY>()

Inherited, see L<Mail::Reporter/"Cleanup">

=back

=head1 DETAILS

Extends L<"DETAILS" in Mail::Box::Manager|Mail::Box::Manager/"DETAILS">.

=head1 DIAGNOSTICS

=over 4

=item Error: Folder $name is not a Mail::Box; cannot add a message.

The folder where the message should be appended to is an object which is
not a folder type which extends L<Mail::Box|Mail::Box>.  Probably, it is not a folder
at all.
Cast by C<appendMessage()>

=item Error: Use appendMessage() to add messages which are not in a folder.

You do not need to copy this message into the folder, because you do
not share the message between folders.
Cast by C<copyMessage()>

=item Warning: Use moveMessage() or copyMessage() to move between open folders.

The message is already part of a folder, and now it should be appended
to a different folder.  You need to decide between copy or move, which
both will clone the message (not the body, because they are immutable).
Cast by C<appendMessage()>

=item Error: cannot create folder $name: higher levels missing.

Unless you set L<create(create_supers)|Mail::Box::Manage::User/"Manage existing folders">, all higher level folders must
exist before this new one can be created.
Cast by C<create()>

=item Error: cannot rename folder $from to $to: higher levels are missing.

Unless you set L<create(create_supers)|Mail::Box::Manage::User/"Manage existing folders">, all higher level folders must
exist before this new one can be created.
Cast by C<rename()>

=item Error: class $package does not implement method $method.

Fatal error: the specific C<$package> (or one of its superclasses) does not
implement this method where it should. This message means that some other
related classes do implement this method however the class at hand does
not.  Probably you should investigate this and probably inform the author
of the package.
Cast by C<notImplemented()>

=item Error: failed for folder default $class: $@

Cast by C<open()>

=item Error: folder $name already exists.

Cast by C<create()>

=item Error: folder $name does not exist, failed opening $type.

The folder does not exist and creating is not permitted (see
L<open(create)|Mail::Box::Manager/"Manage open folders">) or did not succeed.  When you do not have sufficient
access rights to the folder (for instance wrong password for POP3),
this warning will be produced as well.

The manager tried to open a folder of the specified type.  It may help
to explicitly state the type of your folder with the C<type> option.
There will probably be another warning or error message which is related
to this report and provides more details about its cause.  You may also
have a look at L<new(autodetect)|Mail::Box::Manager/"METHODS"> and L<new(folder_types)|Mail::Box::Manager/"METHODS">.
Cast by C<open()>

=item Error: folder $name is already open.

You cannot ask the manager for a folder which is already open. In some
older releases (before MailBox 2.049), this was permitted, but then
behaviour changed, because many nasty side-effects are to be expected.
For instance, an L<Mail::Box::update()|Mail::Box/"The folder"> on one folder handle would
influence the second, probably unexpectedly.
Cast by C<open()>

=item Error: folder $name not under top.

Cast by C<folderCollection()>

=item Warning: folder type $type is unknown, using autodetect.

The specified folder type (see L<open(type)|Mail::Box::Manager/"Manage open folders">, possibly derived from
the folder name when specified as url) is not known to the manager.
This may mean that you forgot to require the L<Mail::Box|Mail::Box> extension
which implements this folder type, but probably it is a typo.  Usually,
the manager is able to figure-out which type to use by itself.
Cast by C<open()>

=item Error: illegal folder URL '$url'.

The folder name was specified as URL, but not according to the syntax.
See L<decodeFolderURL()|Mail::Box::Manager/"Internals"> for an description of the syntax.
Cast by C<open()>

=item Error: no foldername specified to open.

L<open()|Mail::Box::Manager/"Manage open folders"> needs a folder name as first argument (before the list of options),
or with the C<folder> option within the list.  If no name was found, the
MAIL environment variable is checked.  When even that does not result in
a usable folder, then this error is produced.  The error may be caused by
an accidental odd-length option list.
Cast by C<open()>

=item Error: source folder for rename does not exist: $from to $to.

Cast by C<rename()>

=item Error: threader $class is not derived from $base.

Cast by C<discoverThreads()>

=item Error: unusable threader $class: $@

Cast by C<discoverThreads()>

=item Error: user manager requires an identity.

Cast by C<new()>

=item Warning: will never create a folder $name without having write access.

You have set L<open(create)|Mail::Box::Manager/"Manage open folders">, but only want to read the folder.  Create is
only useful for folders which have write or append access modes
(see L<Mail::Box::new(access)|Mail::Box/"Constructors">).
Cast by C<open()>

=item Error: you need to pass a $base derived threader, got $class.

Cast by C<discoverThreads()>

=back

=head1 SEE ALSO

This module is part of Mail-Box version 4.01,
built on December 13, 2025. Website: F<http://perl.overmeer.net/CPAN/>

=head1 LICENSE

For contributors see file ChangeLog.

This software is copyright (c) 2001-2025 by Mark Overmeer.

This is free software; you can redistribute it and/or modify it under
the same terms as the Perl 5 programming language system itself.

